:li

/* binpatch.c: patch one byte in a file */

#include <stdio.h>
#include <fcntl.h>
#include <ctype.h>

extern int errno;

typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned long ulong;
char *progname;
int tohex();


main(int argc,char *argv[]) {
	int argcnt = 1;
	int fd;
	int offset;
	int value;

	progname = argv[0];
	if (argc < 4) helpexit();
	if ((offset = tohex (argv[1]))==-1) {
		fprintf (stderr,"%s: invalid offset\n",progname);
		helpexit();
	}
	if ((value = tohex (argv[2]))==-1) {
		fprintf (stderr,"%s: invalid value\n",progname);
		helpexit();
	}
	if ((fd=open(argv[3],O_RDWR))==-1) {
		fprintf (stderr,"%s: cannot open %s\n",
			progname,argv[1]);
		exit (errno);
	}
	if ((lseek (fd,offset,0))==-1) {
		fprintf (stderr,"%s: lseek() failed\n",progname);
		exit (errno);
	}
	write (fd,&value,1);
	close (fd);
}

int tohex(char *s) {
	char *d;
	int i;
	int result = 0;

	d = s;
	while (*d) {
		*d = toupper (*d);
		d++;
	}
	if (!memcmp(s,"0X",2)) s+=2;
	while (*s) {
		result <<= 4;
		if (!isxdigit(*s)) return (-1);
		i = ( *s >= 'A') ? (*s - 0x37) : (*s - 0x30);
		result += i;
		s++;
	}
	return (result);
}

helpexit() {
	fprintf (stderr,"Aufruf: %s OFFSET (0x....) VALUE (0x..) Datei(en)\n",
		progname);
	exit (1);
}

